//Item_Vuvuzela
//Made by Wrapperup

datablock AudioProfile(vuvuSong)
{
   filename    = "./vuvSong.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock ItemData(vuvItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./vuvuzela.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Vuvuzela";
	iconName = "./icon_vuv";
	doColorShift = false;
	colorShiftColor = "0.25 0.25 0.25 1.000";

	 // Dynamic properties defined by the scripts
	image = vuvImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(vuvImage)
{
   // Basic Item properties
   shapeFile = "./vuvuzela.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "90 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = vuvItem;
   ammo = " ";

   minShotTime = 4000;
   
   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = false;
   
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Sound";
	stateAllowImageChange[1]         = true;

	stateName[2]                    = "Sound";
	stateTransitionOnTimeout[2]     = "Finish";
	stateTimeoutValue[2]            = 0;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateScript[2]                  = "onSound";
	stateWaitForTimeout[2]			= true;
	
	stateName[3]                    = "Finish";
	stateTransitionOnTimeout[3]     = "Ready";
	stateTimeoutValue[3]            = 2;
	stateAllowImageChange[3]        = true;
	stateWaitForTimeout[3]			= true;
};

datablock ShapeBaseImageData(vuvPlayImage)
{
   shapeFile = "./vuvuzela.dts";
   emap = true;
   
   mountPoint = 2;
   offset = "0 1.1 0.35";
   eyeOffset = "0 1 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   firstperson = true;
   correctMuzzleVector = true;

   doColorShift = false;
   
   minShotTime = 4000;
   
   stateName[0]                     = "Activate";
    stateTransitionOnTimeout[0]     = "Finish";
	stateTimeoutValue[0]             = 4.0;
	stateWaitForTimeout[0]			= true;
	stateAllowImageChange[0]        = true;
	stateSound[0]					= vuvuSong;
	
	stateName[1]                     = "Finish";
	stateAllowImageChange[1]        = true;
	stateScript[1]                  = "onFinish";
};

function vuvImage::onSound(%this,%obj,%slot)
{
	if(($Sim::Time - %obj.lastVuv) > 4)
	{
		%obj.lastVuv = $Sim::Time;
		
		%obj.playThread(2,"plant");
		%obj.playThread(1,"root");
		
		%obj.mountImage(vuvPlayImage,0);
	}
}

function vuvPlayImage::onFinish(%this,%obj,%slot)
{
	%obj.mountImage(vuvImage,0);
	%obj.playThread(1,"armReadyRight");
}