//Item_whistle
//Made by Wrapperup

datablock AudioProfile(whistleSound)
{
   filename    = "./whistle.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock ItemData(whistleItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./whistle.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Whistle";
	iconName = "./icon_whistle";
	doColorShift = false;
	colorShiftColor = "0.25 0.25 0.25 1.000";

	 // Dynamic properties defined by the scripts
	image = whistleImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(whistleImage)
{
   // Basic Item properties
   shapeFile = "./whistle.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "-0.20 0 0.11";
   eyeOffset = 0;
   rotation = eulerToMatrix( "-40 0 -90" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = whistleItem;
   ammo = " ";

   minShotTime = 1000;
   
   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = false;

   doColorShift = false;
   
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Ready";

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Sound";
	stateAllowImageChange[1]         = true;

	stateName[2]                    = "Sound";
	stateTransitionOnTimeout[2]     = "Finish";
	stateTimeoutValue[2]            = 0;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateScript[2]                  = "onSound";
	stateWaitForTimeout[2]			= true;
	
	stateName[3]                    = "Finish";
	stateTransitionOnTimeout[3]     = "Ready";
	stateTimeoutValue[3]            = 1;
	stateAllowImageChange[3]        = true;
	stateWaitForTimeout[3]			= true;
};

datablock ShapeBaseImageData(whistlePlayImage)
{
   shapeFile = "./whistle.dts";
   emap = true;
   
   mountPoint = 2;
   offset = "0 0.35 0.18";
   eyeOffset = "0 0.7 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   firstperson = true;
   correctMuzzleVector = true;

   doColorShift = false;
   
   minShotTime = 1000;
   
   stateName[0]                     = "Activate";
    stateTransitionOnTimeout[0]     = "Finish";
	stateTimeoutValue[0]             = 0.3;
	stateWaitForTimeout[0]			= true;
	stateAllowImageChange[0]        = true;
	
	stateName[1]                     = "Finish";
	stateAllowImageChange[1]        = true;
	stateScript[1]                  = "onFinish";
};

function whistleImage::onMount(%this,%obj,%slot)
{
	%obj.playThread(1,"root");
}

function whistleImage::onSound(%this,%obj,%slot)
{
	if(($Sim::Time - %obj.lastwhistle) > 0.3)
	{
		%obj.lastwhistle = $Sim::Time;
		%obj.playThread(1,"shiftAway");
		%obj.playThread(0,"plant");
		
		%obj.mountImage(whistlePlayImage,0);
		
		ServerPlay2D(whistleSound);
	}
}

function whistlePlayImage::onFinish(%this,%obj,%slot)
{
	%obj.mountImage(whistleImage,0);
}